/**
 * Guides functions
 */
'use strict';

/**
 * Creates a guide element.
 */
function createGuideElement(guideId, GuideNameswedish, GuideNameenglish, GuideNamedanish, GuideNamegerman, GuideTextTitleswedish, GuideTextTitleenglish, GuideTextTitledanish, GuideTextTitlegerman, GuideBodyTextswedish, GuideBodyTextenglish, GuideBodyTextdanish, GuideBodyTextgerman, SwedishAudioFile, EnglishAudioFile, DanishAudioFile, GermanAudioFile, SwedishSignVideoFile) {
  var html =
    '<div class="post guide-' + guideId + ' mdl-cell mdl-cell--4-col-phone ' +
    '      mdl-cell--8-col-tablet mdl-cell--12-col-desktop mdl-grid mdl-grid--no-spacing" style="display: flex;">' +
    '  <div class="mdl-card mdl-shadow--2dp" style="width: 100%;">' +
    '    <div class="mdl-card__title mdl-color--light-blue-600 mdl-color-text--white">' +
    '      <h4 class="mdl-card__title-text"></h4>' +
    '    </div>' +
    '    <div class="mdl-card__supporting-text mdl-color-text--grey-600" style="width: auto; display: block;">' +
    '      <form class="guide-form" id="guide-form-' + guideId + '" action="#" >' +

    '        <div class="mdl-grid" style="padding: 0px;">' +
    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="GuideNameswedish mdl-textfield__input" type="text" id="GuideNameswedish-' + guideId + '">' +
    '            <label class="mdl-textfield__label" for="GuideNameswedish-' + guideId + '">Swedish Guide Name</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="GuideNameenglish mdl-textfield__input" type="text" id="GuideNameenglish-' + guideId + '">' +
    '            <label class="mdl-textfield__label" for="GuideNameenglish-' + guideId + '">English Guide Name</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="GuideNamedanish mdl-textfield__input" type="text" id="GuideNamedanish-' + guideId + '">' +
    '            <label class="mdl-textfield__label" for="GuideNamedanish-' + guideId + '">Danish Guide Name</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="GuideNamegerman mdl-textfield__input" type="text" id="GuideNamegerman-' + guideId + '">' +
    '            <label class="mdl-textfield__label" for="GuideNamegerman-' + guideId + '">German Guide Name</label>' +
    '          </div>' +
    '        </div>' +

    '        <div class="mdl-grid" style="padding: 0px;">' +
    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="GuideTextTitleswedish mdl-textfield__input" type="text" id="GuideTextTitleswedish-' + guideId + '">' +
    '            <label class="mdl-textfield__label" for="GuideTextTitleswedish-' + guideId + '">Swedish Guide Text Title</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="GuideTextTitleenglish mdl-textfield__input" type="text" id="GuideTextTitleenglish-' + guideId + '">' +
    '            <label class="mdl-textfield__label" for="GuideTextTitleenglish-' + guideId + '">English Guide Text Title</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="GuideTextTitledanish mdl-textfield__input" type="text" id="GuideTextTitledanish-' + guideId + '">' +
    '            <label class="mdl-textfield__label" for="GuideTextTitledanish-' + guideId + '">Danish Guide Text Title</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <input class="GuideTextTitlegerman mdl-textfield__input" type="text" id="GuideTextTitlegerman-' + guideId + '">' +
    '            <label class="mdl-textfield__label" for="GuideTextTitlegerman-' + guideId + '">German Guide Text Title</label>' +
    '          </div>' +
    '        </div>' +

    '        <div class="mdl-grid" style="padding: 0px;">' +
    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <textarea class="GuideBodyTextswedish mdl-textfield__input" rows="8" id="GuideBodyTextswedish-' + guideId + '"></textarea>' +
    '            <label class="mdl-textfield__label" for="GuideBodyTextswedish-' + guideId + '">Swedish Guide bodytext</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <textarea class="GuideBodyTextenglish mdl-textfield__input" rows="8" id="GuideBodyTextenglish-' + guideId + '"></textarea>' +
    '            <label class="mdl-textfield__label" for="GuideBodyTextenglish-' + guideId + '">English Guide bodytext</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <textarea class="GuideBodyTextdanish mdl-textfield__input" rows="8" id="GuideBodyTextdanish-' + guideId + '"></textarea>' +
    '            <label class="mdl-textfield__label" for="GuideBodyTextdanish-' + guideId + '">Danish Guide bodytext</label>' +
    '          </div>' +

    '          <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label ' +
    '                   mdl-cell mdl-cell--4-col-phone mdl-cell--4-col-tablet mdl-cell--3-col-desktop">' +
    '            <textarea class="GuideBodyTextgerman mdl-textfield__input" rows="8" id="GuideBodyTextgerman-' + guideId + '"></textarea>' +
    '            <label class="mdl-textfield__label" for="GuideBodyTextgerman-' + guideId + '">German Guide bodytext</label>' +
    '          </div>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
    '          <input class="SwedishAudioFile mdl-textfield__input" type="text" id="SwedishAudioFile-' + guideId + '">' +
    '          <label class="mdl-textfield__label" for="SwedishAudioFile-' + guideId + '">SwedishAudioFile</label>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
    '          <input class="EnglishAudioFile mdl-textfield__input" type="text" id="EnglishAudioFile-' + guideId + '">' +
    '          <label class="mdl-textfield__label" for="EnglishAudioFile-' + guideId + '">EnglishAudioFile</label>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
    '          <input class="DanishAudioFile mdl-textfield__input" type="text" id="DanishAudioFile-' + guideId + '">' +
    '          <label class="mdl-textfield__label" for="DanishAudioFile-' + guideId + '">DanishAudioFile</label>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
    '          <input class="GermanAudioFile mdl-textfield__input" type="text" id="GermanAudioFile-' + guideId + '">' +
    '          <label class="mdl-textfield__label" for="GermanAudioFile-' + guideId + '">GermanAudioFile</label>' +
    '        </div>' +

    '        <div class="mdl-textfield mdl-js-textfield mdl-textfield--floating-label">' +
    '          <input class="SwedishSignVideoFile mdl-textfield__input" type="text" id="SwedishSignVideoFile-' + guideId + '">' +
    '          <label class="mdl-textfield__label" for="SwedishSignVideoFile-' + guideId + '">SwedishSignVideoFile</label>' +
    '        </div>' +

    '        <button type="submit" class="mdl-button mdl-js-button mdl-button--raised mdl-js-ripple-effect">Update</button>' +
    '      </form>' +
    '    </div>' +
    '  </div>' +
    '</div>';

  // Create the DOM element from the HTML.
  var div = document.createElement('div');
  div.innerHTML = html;
  var guideElement = div.firstChild;

  var cardTitle = guideElement.getElementsByClassName('mdl-card__title')[0];
  var cardSupportingText = guideElement.getElementsByClassName('mdl-card__supporting-text')[0];

  var guideUpdateForm = guideElement.getElementsByClassName('guide-form')[0];

  var GuideNameswedishInput = guideElement.getElementsByClassName('GuideNameswedish')[0];
  var GuideNameenglishInput = guideElement.getElementsByClassName('GuideNameenglish')[0];
  var GuideNamedanishInput = guideElement.getElementsByClassName('GuideNamedanish')[0];
  var GuideNamegermanInput = guideElement.getElementsByClassName('GuideNamegerman')[0];

  var GuideTextTitleswedishInput = guideElement.getElementsByClassName('GuideTextTitleswedish')[0];
  var GuideTextTitleenglishInput = guideElement.getElementsByClassName('GuideTextTitleenglish')[0];
  var GuideTextTitledanishInput = guideElement.getElementsByClassName('GuideTextTitledanish')[0];
  var GuideTextTitlegermanInput = guideElement.getElementsByClassName('GuideTextTitlegerman')[0];

  var GuideBodyTextswedishInput = guideElement.getElementsByClassName('GuideBodyTextswedish')[0];
  var GuideBodyTextenglishInput = guideElement.getElementsByClassName('GuideBodyTextenglish')[0];
  var GuideBodyTextdanishInput = guideElement.getElementsByClassName('GuideBodyTextdanish')[0];
  var GuideBodyTextgermanInput = guideElement.getElementsByClassName('GuideBodyTextgerman')[0];

  var SwedishAudioFileInput = guideElement.getElementsByClassName('SwedishAudioFile')[0];
  var EnglishAudioFileInput = guideElement.getElementsByClassName('EnglishAudioFile')[0];
  var DanishAudioFileInput = guideElement.getElementsByClassName('DanishAudioFile')[0];
  var GermanAudioFileInput = guideElement.getElementsByClassName('GermanAudioFile')[0];

  var SwedishSignVideoFileInput = guideElement.getElementsByClassName('SwedishSignVideoFile')[0];

  // Set values.   
  guideElement.getElementsByClassName('mdl-card__title-text')[0].innerText = guideId;

  guideElement.getElementsByClassName('GuideNameswedish')[0].value = GuideNameswedish;
  guideElement.getElementsByClassName('GuideNameenglish')[0].value = GuideNameenglish;
  guideElement.getElementsByClassName('GuideNamedanish')[0].value = GuideNamedanish;
  guideElement.getElementsByClassName('GuideNamegerman')[0].value = GuideNamegerman;

  guideElement.getElementsByClassName('GuideTextTitleswedish')[0].value = GuideTextTitleswedish;
  guideElement.getElementsByClassName('GuideTextTitleenglish')[0].value = GuideTextTitleenglish;
  guideElement.getElementsByClassName('GuideTextTitledanish')[0].value = GuideTextTitledanish;
  guideElement.getElementsByClassName('GuideTextTitlegerman')[0].value = GuideTextTitlegerman;

  guideElement.getElementsByClassName('GuideBodyTextswedish')[0].value = GuideBodyTextswedish;
  guideElement.getElementsByClassName('GuideBodyTextenglish')[0].value = GuideBodyTextenglish;
  guideElement.getElementsByClassName('GuideBodyTextdanish')[0].value = GuideBodyTextdanish;
  guideElement.getElementsByClassName('GuideBodyTextgerman')[0].value = GuideBodyTextgerman;

  guideElement.getElementsByClassName('SwedishAudioFile')[0].value = SwedishAudioFile;
  guideElement.getElementsByClassName('EnglishAudioFile')[0].value = EnglishAudioFile;
  guideElement.getElementsByClassName('DanishAudioFile')[0].value = DanishAudioFile;
  guideElement.getElementsByClassName('GermanAudioFile')[0].value = GermanAudioFile;

  guideElement.getElementsByClassName('SwedishSignVideoFile')[0].value = SwedishSignVideoFile;

  if (componentHandler) {
    componentHandler.upgradeElements(guideElement.getElementsByClassName('mdl-textfield'));
  }

  // Update guide data
  guideUpdateForm.onsubmit = function (e) {
    e.preventDefault();
    updateGuideData(guideId, GuideNameswedishInput.value, GuideNameenglishInput.value, GuideNamedanishInput.value, GuideNamegermanInput.value, GuideTextTitleswedishInput.value, GuideTextTitleenglishInput.value, GuideTextTitledanishInput.value, GuideTextTitlegermanInput.value, GuideBodyTextswedishInput.value, GuideBodyTextenglishInput.value, GuideBodyTextdanishInput.value, GuideBodyTextgermanInput.value, SwedishAudioFileInput.value, EnglishAudioFileInput.value, DanishAudioFileInput.value, GermanAudioFileInput.value, SwedishSignVideoFileInput.value);
  };

  cardTitle.addEventListener('click', function () {
    if (cardSupportingText.style.display == 'none') {
      cardSupportingText.style.display = 'block';
    } else {
      cardSupportingText.style.display = 'none';
    }

  });

  return guideElement;
}

/**
 * Updates Guide data on the Firebase DB.
 */
function updateGuideData(guideId, GuideNameswedish, GuideNameenglish, GuideNamedanish, GuideNamegerman, GuideTextTitleswedish, GuideTextTitleenglish, GuideTextTitledanish, GuideTextTitlegerman, GuideBodyTextswedish, GuideBodyTextenglish, GuideBodyTextdanish, GuideBodyTextgerman, SwedishAudioFile, EnglishAudioFile, DanishAudioFile, GermanAudioFile, SwedishSignVideoFile) {

  var guideData = {
    GuideName: {
      swedish: GuideNameswedish,
      english: GuideNameenglish,
      danish: GuideNamedanish,
      german: GuideNamegerman
    },
    GuideTextTitle: {
      swedish: GuideTextTitleswedish,
      english: GuideTextTitleenglish,
      danish: GuideTextTitledanish,
      german: GuideTextTitlegerman
    },
    GuideBodyText: {
      swedish: GuideBodyTextswedish,
      english: GuideBodyTextenglish,
      danish: GuideBodyTextdanish,
      german: GuideBodyTextgerman
    },
    SwedishAudioFile: SwedishAudioFile,
    EnglishAudioFile: EnglishAudioFile,
    DanishAudioFile: DanishAudioFile,
    GermanAudioFile: GermanAudioFile,
    SwedishSignVideoFile: SwedishSignVideoFile
  };
  var updates = {};
  updates['/GuideData/' + guideId] = guideData;

  return firebase.database().ref().update(updates);
}


